                    PROGRAM

  include('keycodes.clw')

                    MAP
                        MODULE('CMagFSWatcher.DLL')
SetupPostDetails          PROCEDURE(long parEvent, long parControl , long parThread, long parPriority),NAME('SetupControlDetails'),PASCAL,DLL(True)
CreateWatcher             PROCEDURE(),NAME('CreateWatcher'),PASCAL,DLL(True)
SetupWatchedFolder        PROCEDURE(*CSTRING parFolder),NAME('SetupWatchedFolder'),PASCAL,RAW,DLL(True)
SetupCopyFolder           PROCEDURE(*CSTRING parFolder),NAME('SetupCopyFolder'),PASCAL,RAW,DLL(True)
SetupWatchFilter          PROCEDURE(*CSTRING parFilter),NAME('SetupWatchFilter'),PASCAL,RAW,DLL(True)
EnableWatching            PROCEDURE(),NAME('EnableWatching'),PASCAL,DLL(True)
DisableWatching           PROCEDURE(),NAME('DisableWatching'),PASCAL,DLL(True)
IncludeSubdirectories     PROCEDURE(),NAME('IncludeSubdirectories'),PASCAL,DLL(True)
ExcludeSubdirectories     PROCEDURE(),NAME('ExcludeSubdirectories'),PASCAL,DLL(True)
ReturnFilename            PROCEDURE(),*CString,NAME('ReturnFilename'),PASCAL,DLL(True)
SetupDebug                PROCEDURE(long parDebug),NAME('SetupDebug'),PASCAL,DLL(True)
                        END
                    END

fileQueue   Queue,pre(FQ)
filename      cstring(261)
            end

watchedFolder       cstring(261)
watchFilter         cstring(41)
copyFolder          cstring(261)
debug               long

Window WINDOW('Watching for File Creation/Change'),AT(,,297,229),CENTER,ICON(icon:exclamation),TIMER(600), |
         SYSTEM,GRAY,MAX,RESIZE,AUTO
       LIST,AT(7,1,285,166),USE(?List1),HVSCROLL,ALRT(MouseLeft2),VCR,FORMAT('20L(2)|M~File~'),FROM(fileQueue)
       STRING('Watched Folder'),AT(7,173),USE(?String2)
       ENTRY(@S255),AT(67,174,208,10),USE(watchedFolder)
       BUTTON('...'),AT(280,174,10,10),USE(?locateWatchedFolder)
       STRING('Copy Folder'),AT(7,185),USE(?String3)
       ENTRY(@S255),AT(67,185,208,10),USE(copyFolder)
       BUTTON('...'),AT(280,185,10,10),USE(?locateCopyFolder)
       STRING('Watch Filter'),AT(7,197),USE(?String1)
       ENTRY(@S40),AT(67,197,208,10),USE(watchFilter)
       BUTTON('&Enable'),AT(7,212,45,14),USE(?toggle_enable)
       BUTTON('Clear'),AT(247,212,45,14),USE(?clear)
       CHECK('Debug'),AT(67,214),USE(debug),VALUE('1','0')
     END


fileWatcherEvent     long(event:user+1024)
returnFilename       cstring(261)
count                long
initialised          long(false)
pathsSetup           long(false)

    CODE

    watchedFolder = getini('NETWinWatcher','watchedFolder',,'.\NETWinWatcher.INI')
    copyFolder = getini('NETWinWatcher','copyFolder',,'.\NETWinWatcher.INI')

    open(window)

    accept
      case event()
      of fileWatcherEvent
        FQ:filename = ReturnFilename()
        add(fileQueue)
      end
      case field()
      of ?debug
        case event()
        of event:newselection
          SetupDebug(debug)
        end
      of ?watchedFolder
        case event()
        of event:accepted
          if initialised
            SetupWatchedFolder(watchedFolder)
          end
        end
      of ?locateWatchedFolder
        case event()
        of event:accepted
          if FileDialog('Select Watched Folder',watchedFolder,,file:directory+file:keepdir)
            if initialised
              SetupWatchedFolder(watchedFolder)
            end
          end
        end
      of ?locateCopyFolder
        case event()
        of event:accepted
          if FileDialog('Select Copy To Folder',copyFolder,,file:directory+file:keepdir)
            if initialised
              SetupCopyFolder(copyFolder)
            end
          end
        end
      of ?watchFilter
        case event()
        of event:accepted
          if initialised
            SetupWatchFilter(watchFilter)
          end
        end
      of ?toggle_enable
        case event()
        of event:accepted
          case ?toggle_enable{prop:text}
          of '&Enable'
            if not initialised
              do initialSetup
              if pathsSetup
                initialised = True
              else
                message('Both Watched and Copy paths must be setup and exist on disk','Setup Error',icon:exclamation)
                cycle
              end
            end
            EnableWatching()
            ?toggle_enable{prop:text} = '&Disable'
            disable(?watchFilter)
            disable(?debug)
          of '&Disable'
            DisableWatching()
            ?toggle_enable{prop:text} = '&Enable'
            enable(?watchFilter)
          end
        end
      of ?clear
        case event()
        of event:accepted
          case message('Physically Delete All items from Copy folder?','Delete Copied Items',icon:exclamation,|
          button:yes+button:no,button:no)
          of button:yes
            loop count = records(fileQueue) to 1 by -1
              get(fileQueue,count)
              if not errorcode()
                remove(fileQueue.filename)
                delete(fileQueue)
              end
            end
          end
        end
      of ?List1
        case event()
        of event:alertkey
          if choice(?List1)
            get(fileQueue,choice(?List1))
            if not errorcode()
              run('notepad.exe ' & FQ:filename)
            end
          end
        end
      end
    end

    close(window)

    putini('NETWinWatcher','watchedFolder',watchedFolder,'.\NETWinWatcher.INI')
    putini('NETWinWatcher','copyFolder',copyFolder,'.\NETWinWatcher.INI')


initialSetup        routine

    if watchedFolder = '' then exit end
    if copyFolder = '' then exit end
    if not exists(watchedFolder) then exit end
    if not exists(copyFolder) then exit end
    pathsSetup = True

    SetupPostDetails(fileWatcherEvent,0,thread(),1)
    SetupDebug(debug)
    CreateWatcher()
    SetupWatchedFolder(watchedFolder)
    SetupCopyFolder(copyFolder)
    watchFilter = ''
    SetupWatchFilter(watchFilter)
    ExcludeSubdirectories()
