                              MEMBER

  INCLUDE('Equates.clw'),ONCE

                              MAP
GetColorName                    PROCEDURE(LONG C),STRING
GetColor                        PROCEDURE(STRING N),LONG
HexToLong                       PROCEDURE(STRING Hex),LONG
LongToHex                       PROCEDURE(LONG L),STRING
                                INCLUDE('StMhGrad.inc')
                              END

HexDigits                     STRING('0123456789ABCDEF')

ST::SetGradient               PROCEDURE(SIGNED FEQ,BYTE Type,LONG FromColor,LONG ToColor)
  CODE
  FEQ{PROP:GradientType     } = Type
  FEQ{PROP:GradientFromColor} = FromColor
  FEQ{PROP:GradientToColor  } = ToColor

ST::BuildGradient             PROCEDURE(*BYTE Type,*LONG FromColor,*LONG ToColor,<BOOL CommandToClipboard>)!,BYTE
                              MAP
InitLocalVars                   PROCEDURE
AssignOutputVars                PROCEDURE
BuildGradient                   PROCEDURE
                              END
_Type                           BYTE,AUTO
_FromColor                      LONG,AUTO
_ToColor                        LONG,AUTO
WasGradientBuilt                BOOL(FALSE)
  CODE
  InitLocalVars
  BuildGradient
  AssignOutputVars
  RETURN WasGradientBuilt

InitLocalVars                 PROCEDURE
  CODE
  WasGradientBuilt = FALSE
  IF Type=0 AND FromColor=0 AND ToColor=0
    _Type      = GradientTypes:Vertical
    _FromColor = COLOR:White
    _ToColor   = COLOR:Black
  ELSE
    _Type      = Type
    _FromColor = FromColor
    _ToColor   = ToColor
  END

AssignOutputVars              PROCEDURE
  CODE
  IF WasGradientBuilt
    Type      = _Type
    FromColor = _FromColor
    ToColor   = _ToColor
  END

BuildGradient                 PROCEDURE
                              MAP
UseColorDialog                  PROCEDURE(STRING Title,*LONG ColorOut)
                              END
FromColorName                   STRING(50)
ToColorName                     STRING(50)
Window                          WINDOW('BoxSoft Super Stuff - Gradient Builder'),AT(,,341,113),CENTER,GRAY,SYSTEM,FONT('Tahoma', |
                                    9,,,CHARSET:DEFAULT),DOUBLE
                                  OPTION('Type'),AT(2,2,102,106),USE(_Type),BOXED
                                    RADIO('Off'),AT(10,12),USE(?Type:Off),VALUE('0')
                                    RADIO('Vertical'),AT(10,22),USE(?Type:Vertical),VALUE('1')
                                    RADIO('Horizontal'),AT(10,32),USE(?Type:Horizontal),VALUE('2')
                                    RADIO('VerticalCylinder'),AT(10,42),USE(?Type:VerticalCylinder),VALUE('3')
                                    RADIO('HorizontalCylinder'),AT(10,52),USE(?Type:HorizontalCylinder),VALUE('4')
                                    RADIO('DiagonalTopLeft'),AT(10,62),USE(?Type:DiagonalTopLeft),VALUE('5')
                                    RADIO('DiagonalBottomLeft'),AT(10,72),USE(?Type:DiagonalBottomLeft),VALUE('6')
                                    RADIO('DiagonalTopRight'),AT(10,82),USE(?Type:DiagonalTopRight),VALUE('7')
                                    RADIO('DiagonalBottomRight'),AT(10,92),USE(?Type:DiagonalBottomRight), |
                                        VALUE('8')
                                  END
                                  GROUP('Color'),AT(108,2,123,62),USE(?GROUP:Color),BOXED
                                    PROMPT('From:'),AT(115,14),USE(?PROMPT:FromColor)
                                    ENTRY(@S50),AT(137,13,74,12),USE(FromColorName),REQ
                                    BUTTON('...'),AT(215,13,12,12),USE(?BUTTON:FromColor)
                                    PROMPT('To:'),AT(115,30),USE(?PROMPT:ToColor)
                                    ENTRY(@s50),AT(137,29,74,12),USE(ToColorName),REQ
                                    BUTTON('...'),AT(215,29,12,12),USE(?BUTTON:ToColor)
                                    BUTTON('&Swap'),AT(137,45,,14),USE(?BUTTON:SwapColor)
                                  END
                                  BUTTON('&OK'),AT(183,78,48),USE(?BUTTON:Ok),DEFAULT,REQ
                                  BUTTON('Cancel'),AT(183,95,48,14),USE(?BUTTON:Cancel)
                                  BOX,AT(234,6,103,103),USE(?Box),COLOR(COLOR:Black),FILL(COLOR:Black),LINEWIDTH(1)
                                END
  CODE
  OPEN(Window)
  DO SetColorNames
  DO ShowSampleGradient
  ACCEPT
    CASE EVENT()
    OF EVENT:Accepted OROF EVENT:NewSelection
      DO TakeAccepted
      DO ShowSampleGradient
    END
  END
  IF CommandToClipboard
    SETCLIPBOARD('ST::SetGradient(?, GradientTypes:'& (?Type:Off+_Type){PROP:Text} &', '& CLIP(FromColorName) &', '& CLIP(ToColorName) &')')
  END
  
SetColorNames                 ROUTINE
  CHANGE(?FromColorName, GetColorName(_FromColor))
  CHANGE(?ToColorName  , GetColorName(_ToColor  ))

ParseColorNames               ROUTINE
  _FromColor = GetColor(FromColorName)
  _ToColor   = GetColor(ToColorName  )
  DO SetColorNames
  
TakeAccepted                  ROUTINE
  CASE FIELD()
  OF ?BUTTON:Ok       ;  POST(EVENT:CloseWindow); WasGradientBuilt = TRUE
  OF ?BUTTON:Cancel   ;  POST(EVENT:CloseWindow)
  OF ?BUTTON:FromColor;  UseCOLORDIALOG('From Color', _FromColor)
  OF ?BUTTON:ToColor  ;  UseCOLORDIALOG('To Color'  , _ToColor  )
  OF ?BUTTON:SwapColor;  DO SwapColor
  END
  
SwapColor                     ROUTINE
  DATA
_SwapColor  LIKE(_FromColor)
SwapName    LIKE(FromColorName)
  CODE
  _SwapColor = _FromColor;  SwapName      = FromColorName
  _FromColor = _ToColor  ;  FromColorName = ToColorName
  _ToColor   = _SwapColor;  ToColorName   = SwapName
  DO ShowSampleGradient

ShowSampleGradient            ROUTINE
  DO ParseColorNames
  ST::SetGradient(?Box, _Type, _FromColor, _ToColor)

UseColorDialog                PROCEDURE(STRING Title,*LONG ColorOut)
  CODE
  IF COLORDIALOG(Title, ColorOut)
    DO SetColorNames
  END

GetColorName                  PROCEDURE(LONG C)!,STRING
N CSTRING(50),AUTO
  CODE
  CASE C
  OF COLOR:NONE               ; N = 'COLOR:NONE'
  OF COLOR:SCROLLBAR          ; N = 'COLOR:SCROLLBAR'
  OF COLOR:BACKGROUND         ; N = 'COLOR:BACKGROUND'
  OF COLOR:ACTIVECAPTION      ; N = 'COLOR:ACTIVECAPTION'
  OF COLOR:INACTIVECAPTION    ; N = 'COLOR:INACTIVECAPTION'
  OF COLOR:MENU               ; N = 'COLOR:MENU'
  OF COLOR:MENUBAR            ; N = 'COLOR:MENUBAR'
  OF COLOR:WINDOW             ; N = 'COLOR:WINDOW'
  OF COLOR:WINDOWFRAME        ; N = 'COLOR:WINDOWFRAME'
  OF COLOR:MENUTEXT           ; N = 'COLOR:MENUTEXT'
  OF COLOR:WINDOWTEXT         ; N = 'COLOR:WINDOWTEXT'
  OF COLOR:CAPTIONTEXT        ; N = 'COLOR:CAPTIONTEXT'
  OF COLOR:ACTIVEBORDER       ; N = 'COLOR:ACTIVEBORDER'
  OF COLOR:INACTIVEBORDER     ; N = 'COLOR:INACTIVEBORDER'
  OF COLOR:APPWORKSPACE       ; N = 'COLOR:APPWORKSPACE'
  OF COLOR:HIGHLIGHT          ; N = 'COLOR:HIGHLIGHT'
  OF COLOR:HIGHLIGHTTEXT      ; N = 'COLOR:HIGHLIGHTTEXT'
  OF COLOR:BTNFACE            ; N = 'COLOR:BTNFACE'
  OF COLOR:BTNSHADOW          ; N = 'COLOR:BTNSHADOW'
  OF COLOR:GRAYTEXT           ; N = 'COLOR:GRAYTEXT'
  OF COLOR:BTNTEXT            ; N = 'COLOR:BTNTEXT'
  OF COLOR:INACTIVECAPTIONTEXT; N = 'COLOR:INACTIVECAPTIONTEXT'
  OF COLOR:BTNHIGHLIGHT       ; N = 'COLOR:BTNHIGHLIGHT'
  OF COLOR:Black              ; N = 'COLOR:Black'
  OF COLOR:Maroon             ; N = 'COLOR:Maroon'
  OF COLOR:Green              ; N = 'COLOR:Green'
  OF COLOR:Olive              ; N = 'COLOR:Olive'
  OF COLOR:Orange             ; N = 'COLOR:Orange'
  OF COLOR:Navy               ; N = 'COLOR:Navy'
  OF COLOR:Purple             ; N = 'COLOR:Purple'
  OF COLOR:Teal               ; N = 'COLOR:Teal'
  OF COLOR:Gray               ; N = 'COLOR:Gray'
  OF COLOR:Silver             ; N = 'COLOR:Silver'
  OF COLOR:Red                ; N = 'COLOR:Red'
  OF COLOR:Lime               ; N = 'COLOR:Lime'
  OF COLOR:Yellow             ; N = 'COLOR:Yellow'
  OF COLOR:Blue               ; N = 'COLOR:Blue'
  OF COLOR:Fuchsia            ; N = 'COLOR:Fuchsia'
  OF COLOR:Aqua               ; N = 'COLOR:Aqua'
  OF COLOR:White              ; N = 'COLOR:White'
  ELSE
    N = LongToHex(C)
  END
  RETURN N

GetColor                      PROCEDURE(STRING N)!,LONG
C                               LONG,AUTO
  CODE
  CASE UPPER(N)
  OF   'COLOR:NONE'                OROF 'NONE'
  OROF ''                                                    ; C = COLOR:NONE               
  OF   'COLOR:SCROLLBAR'           OROF 'SCROLLBAR'          ; C = COLOR:SCROLLBAR          
  OF   'COLOR:BACKGROUND'          OROF 'BACKGROUND'         ; C = COLOR:BACKGROUND         
  OF   'COLOR:ACTIVECAPTION'       OROF 'ACTIVECAPTION'      ; C = COLOR:ACTIVECAPTION      
  OF   'COLOR:INACTIVECAPTION'     OROF 'INACTIVECAPTION'    ; C = COLOR:INACTIVECAPTION    
  OF   'COLOR:MENU'                OROF 'MENU'               ; C = COLOR:MENU               
  OF   'COLOR:MENUBAR'             OROF 'MENUBAR'            ; C = COLOR:MENUBAR            
  OF   'COLOR:WINDOW'              OROF 'WINDOW'             ; C = COLOR:WINDOW             
  OF   'COLOR:WINDOWFRAME'         OROF 'WINDOWFRAME'        ; C = COLOR:WINDOWFRAME        
  OF   'COLOR:MENUTEXT'            OROF 'MENUTEXT'           ; C = COLOR:MENUTEXT           
  OF   'COLOR:WINDOWTEXT'          OROF 'WINDOWTEXT'         ; C = COLOR:WINDOWTEXT         
  OF   'COLOR:CAPTIONTEXT'         OROF 'CAPTIONTEXT'        ; C = COLOR:CAPTIONTEXT        
  OF   'COLOR:ACTIVEBORDER'        OROF 'ACTIVEBORDER'       ; C = COLOR:ACTIVEBORDER       
  OF   'COLOR:INACTIVEBORDER'      OROF 'INACTIVEBORDER'     ; C = COLOR:INACTIVEBORDER     
  OF   'COLOR:APPWORKSPACE'        OROF 'APPWORKSPACE'       ; C = COLOR:APPWORKSPACE       
  OF   'COLOR:HIGHLIGHT'           OROF 'HIGHLIGHT'          ; C = COLOR:HIGHLIGHT          
  OF   'COLOR:HIGHLIGHTTEXT'       OROF 'HIGHLIGHTTEXT'      ; C = COLOR:HIGHLIGHTTEXT      
  OF   'COLOR:BTNFACE'             OROF 'BTNFACE'            ; C = COLOR:BTNFACE            
  OF   'COLOR:BTNSHADOW'           OROF 'BTNSHADOW'          ; C = COLOR:BTNSHADOW          
  OF   'COLOR:GRAYTEXT'            OROF 'GRAYTEXT'           ; C = COLOR:GRAYTEXT           
  OF   'COLOR:BTNTEXT'             OROF 'BTNTEXT'            ; C = COLOR:BTNTEXT            
  OF   'COLOR:INACTIVECAPTIONTEXT' OROF 'INACTIVECAPTIONTEXT'; C = COLOR:INACTIVECAPTIONTEXT
  OF   'COLOR:BTNHIGHLIGHT'        OROF 'BTNHIGHLIGHT'       ; C = COLOR:BTNHIGHLIGHT       
  OF   'COLOR:BLACK'               OROF 'BLACK'              ; C = COLOR:Black              
  OF   'COLOR:MAROON'              OROF 'MAROON'             ; C = COLOR:Maroon             
  OF   'COLOR:GREEN'               OROF 'GREEN'              ; C = COLOR:Green              
  OF   'COLOR:OLIVE'               OROF 'OLIVE'              ; C = COLOR:Olive              
  OF   'COLOR:ORANGE'              OROF 'ORANGE'             ; C = COLOR:Orange             
  OF   'COLOR:NAVY'                OROF 'NAVY'               ; C = COLOR:Navy               
  OF   'COLOR:PURPLE'              OROF 'PURPLE'             ; C = COLOR:Purple             
  OF   'COLOR:TEAL'                OROF 'TEAL'               ; C = COLOR:Teal               
  OF   'COLOR:GRAY'                OROF 'GRAY'               ; C = COLOR:Gray               
  OF   'COLOR:SILVER'              OROF 'SILVER'             ; C = COLOR:Silver             
  OF   'COLOR:RED'                 OROF 'RED'                ; C = COLOR:Red                
  OF   'COLOR:LIME'                OROF 'LIME'               ; C = COLOR:Lime               
  OF   'COLOR:YELLOW'              OROF 'YELLOW'             ; C = COLOR:Yellow             
  OF   'COLOR:BLUE'                OROF 'BLUE'               ; C = COLOR:Blue               
  OF   'COLOR:FUCHSIA'             OROF 'FUCHSIA'
  OROF 'COLOR:FUSCHIA'             OROF 'FUSCHIA'            ; C = COLOR:Fuchsia            
  OF   'COLOR:AQUA'                OROF 'AQUA'               ; C = COLOR:Aqua               
  OF   'COLOR:WHITE'               OROF 'WHITE'              ; C = COLOR:White              
  ELSE
    C = HexToLong(N)
  END
  RETURN C

HexToLong                     PROCEDURE(STRING Hex)!,LONG
LongVal                         LONG(0)
Pos                             BYTE,AUTO
Digit                           SHORT,AUTO
  CODE
  Hex = UPPER(LEFT(Hex))
  LOOP Pos = 1 TO SIZE(Hex)
    Digit = INSTRING(Hex[Pos], HexDigits) - 1
    IF Digit < 0 THEN BREAK.
    LongVal = BOR(BSHIFT(LongVal, 4), Digit)
  END
  !MESSAGE('LongVal='& LongVal)
  RETURN LongVal

LongToHex                     PROCEDURE(LONG L)!,STRING
HexString                       CSTRING(11)
HexDigitValue                   BYTE,AUTO
  CODE
  LOOP WHILE L <> 0 OR LEN(HexString) < 6 OR LEN(HexString) % 2
    HexDigitValue = L % 16
    HexString = HexDigits[HexDigitValue+1] & HexString
    L /= 16
  END
  !MESSAGE('HexString='& HexString)
  RETURN '0' & HexString &'h'
  